diff --git a/MAINTAINERS b/MAINTAINERS
index c00081cd8..4798fb258 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -1156,6 +1156,7 @@ F: lib/librte_metrics/
 Bit-rate statistics
 M: Remy Horton <remy.horton@intel.com>
 F: lib/librte_bitratestats/
+F: test/test/test_bitratestats.c
 
 Latency statistics
 M: Reshma Pattan <reshma.pattan@intel.com>
diff --git a/test/test/Makefile b/test/test/Makefile
index 66e98066f..c030ab111 100644
--- a/test/test/Makefile
+++ b/test/test/Makefile
@@ -183,6 +183,7 @@ SRCS-$(CONFIG_RTE_LIBRTE_PMD_RING) += test_pmd_ring_perf.c
 SRCS-$(CONFIG_RTE_LIBRTE_CRYPTODEV) += test_cryptodev_blockcipher.c
 SRCS-$(CONFIG_RTE_LIBRTE_CRYPTODEV) += test_cryptodev.c
 SRCS-$(CONFIG_RTE_LIBRTE_CRYPTODEV) += test_cryptodev_asym.c
+SRCS-$(CONFIG_RTE_LIBRTE_BITRATE) += test_bitratestats.c
 
 ifeq ($(CONFIG_RTE_COMPRESSDEV_TEST),y)
 SRCS-$(CONFIG_RTE_LIBRTE_COMPRESSDEV) += test_compressdev.c
diff --git a/test/test/autotest_data.py b/test/test/autotest_data.py
index f68d9b111..b253bf8f0 100644
--- a/test/test/autotest_data.py
+++ b/test/test/autotest_data.py
@@ -482,6 +482,12 @@
         "Func":    default_autotest,
         "Report":  None,
     },
+    {
+        "Name":    "Bitratestats autotest",
+        "Command": "bitratestats_autotest",
+        "Func":    default_autotest,
+        "Report":  None,
+    },
     #
     #Please always keep all dump tests at the end and together!
     #
diff --git a/test/test/meson.build b/test/test/meson.build
index 087ffdb91..f40a28f27 100644
--- a/test/test/meson.build
+++ b/test/test/meson.build
@@ -9,6 +9,7 @@ test_sources = files('commands.c',
 	'test_alarm.c',
 	'test_atomic.c',
 	'test_barrier.c',
+	'test_bitratestats.c',
 	'test_bpf.c',
 	'test_byteorder.c',
 	'test_cmdline.c',
@@ -104,6 +105,7 @@ test_sources = files('commands.c',
 )
 
 test_deps = ['acl',
+	'bitratestats',
 	'bpf',
 	'cfgfile',
 	'cmdline',
@@ -116,6 +118,7 @@ test_deps = ['acl',
 	'hash',
 	'lpm',
 	'member',
+	'metrics',
 	'pipeline',
 	'port',
 	'reorder',
@@ -128,6 +131,7 @@ test_names = [
 	'alarm_autotest',
 	'atomic_autotest',
 	'barrier_autotest',
+	'bitratestats_autotest',
 	'byteorder_autotest',
 	'cmdline_autotest',
 	'common_autotest',
diff --git a/test/test/test_bitratestats.c b/test/test/test_bitratestats.c
new file mode 100644
index 000000000..32b1b0fc0
--- /dev/null
+++ b/test/test/test_bitratestats.c
@@ -0,0 +1,226 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright(c) 2018 Intel Corporation
+ */
+
+#include <stdio.h>
+#include <stdint.h>
+#include <string.h>
+
+#include <errno.h>
+#include <rte_lcore.h>
+#include <rte_memzone.h>
+#include <rte_metrics.h>
+#include <rte_bitrate.h>
+
+#include "sample_packet_forward.h"
+#include "test.h"
+
+#define BIT_NUM_PACKETS 10
+#define QUEUE_ID 0
+
+uint16_t portid;
+struct rte_stats_bitrates *bitrate_data;
+struct rte_ring *ring;
+
+/* To test whether rte_stats_bitrate_create is successful */
+static int
+test_stats_bitrate_create(void)
+{
+	bitrate_data = rte_stats_bitrate_create();
+	TEST_ASSERT(bitrate_data != NULL, "rte_stats_bitrate_create failed");
+
+	return TEST_SUCCESS;
+}
+
+/* To test bit rate registration */
+static int
+test_stats_bitrate_reg(void)
+{
+	int ret = 0;
+
+	/* Test to register bit rate without metrics init */
+	ret = rte_stats_bitrate_reg(bitrate_data);
+	TEST_ASSERT(ret < 0, "Test Failed: rte_stats_bitrate_reg succeeded "
+			"without metrics init, ret:%d", ret);
+
+	/* Metrics initialization */
+	rte_metrics_init(rte_socket_id());
+	/* Test to register bit rate after metrics init */
+	ret = rte_stats_bitrate_reg(bitrate_data);
+	TEST_ASSERT((ret >= 0), "Test Failed: rte_stats_bitrate_reg %d", ret);
+
+	return TEST_SUCCESS;
+}
+
+/* To test the bit rate registration with invalid pointer */
+static int
+test_stats_bitrate_reg_invalidpointer(void)
+{
+	int ret = 0;
+
+	ret = rte_stats_bitrate_reg(NULL);
+	TEST_ASSERT(ret < 0, "Test Failed: Expected failure < 0 but "
+			"got %d", ret);
+
+	return TEST_SUCCESS;
+}
+
+/* To test bit rate calculation with invalid bit rate data pointer */
+static int
+test_stats_bitrate_calc_invalid_bitrate_data(void)
+{
+	int ret = 0;
+
+	ret = rte_stats_bitrate_calc(NULL, portid);
+	TEST_ASSERT(ret < 0, "Test Failed: rte_stats_bitrate_calc "
+			"ret:%d", ret);
+
+	return TEST_SUCCESS;
+}
+
+/* To test the bit rate calculation with invalid portid
+ * (higher than max ports)
+ */
+static int
+test_stats_bitrate_calc_invalid_portid_1(void)
+{
+	int ret = 0;
+
+	ret = rte_stats_bitrate_calc(bitrate_data, 33);
+	TEST_ASSERT(ret == -EINVAL, "Test Failed: Expected -%d for higher "
+			"portid rte_stats_bitrate_calc ret:%d", EINVAL, ret);
+
+	return TEST_SUCCESS;
+}
+
+/* To test the bit rate calculation with invalid portid (lesser than 0) */
+static int
+test_stats_bitrate_calc_invalid_portid_2(void)
+{
+	int ret = 0;
+
+	ret = rte_stats_bitrate_calc(bitrate_data, -1);
+	TEST_ASSERT(ret == -EINVAL, "Test Failed: Expected -%d for invalid "
+			"portid rte_stats_bitrate_calc ret:%d", EINVAL, ret);
+
+	return TEST_SUCCESS;
+}
+
+/* To test the bit rate calculation with non-existing portid */
+static int
+test_stats_bitrate_calc_non_existing_portid(void)
+{
+	int ret = 0;
+
+	ret = rte_stats_bitrate_calc(bitrate_data, 31);
+	TEST_ASSERT(ret ==  -EINVAL, "Test Failed: Expected -%d for "
+			"non-existing portid rte_stats_bitrate_calc ret:%d",
+			EINVAL, ret);
+
+	return TEST_SUCCESS;
+}
+
+/* To test the bit rate calculation with valid bit rate data, valid portid */
+static int
+test_stats_bitrate_calc(void)
+{
+	int ret = 0;
+
+	ret = rte_stats_bitrate_calc(bitrate_data, portid);
+	TEST_ASSERT(ret >= 0, "Test Failed: Expected >=0 for valid portid "
+			"rte_stats_bitrate_calc ret:%d", ret);
+
+	return TEST_SUCCESS;
+}
+
+static int
+test_bit_packet_forward(void)
+{
+	int ret;
+	struct rte_mbuf *pbuf[BIT_NUM_PACKETS] = { };
+	struct rte_mempool *mp;
+	char poolname[] = "mbuf_pool";
+	ret = test_get_mbuf_from_pool(&mp, pbuf, poolname);
+	if (ret < 0) {
+		printf("allocate mbuf pool Failed\n");
+		return TEST_FAILED;
+	}
+	ret = test_packet_forward(pbuf, portid, QUEUE_ID);
+	if (ret < 0)
+		printf("send pkts Failed\n");
+	test_put_mbuf_to_pool(mp, pbuf);
+
+	return TEST_SUCCESS;
+}
+
+static int
+test_bit_ring_setup(void)
+{
+	test_ring_setup(&ring, &portid);
+	printf("port in ring setup : %d\n", portid);
+
+	return TEST_SUCCESS;
+}
+
+static void
+test_bit_ring_free(void)
+{
+	test_ring_free(ring);
+	test_vdev_uninit("net_ring_net_ringa");
+	rte_memzone_free(rte_memzone_lookup("RTE_METRICS"));
+}
+
+static struct
+unit_test_suite bitratestats_testsuite  = {
+	.suite_name = "BitRate Stats Unit Test Suite",
+	.setup = test_bit_ring_setup,
+	.teardown = test_bit_ring_free,
+	.unit_test_cases = {
+		/* TEST CASE 1: Test to create bit rate data */
+		TEST_CASE(test_stats_bitrate_create),
+
+		/* TEST CASE 2: Test to register bit rate metrics
+		 * without metrics init and after metrics init
+		 */
+		TEST_CASE(test_stats_bitrate_reg),
+
+		/* TEST CASE 3: Test to register bit rate metrics
+		 * with invalid bit rate data
+		 */
+		TEST_CASE(test_stats_bitrate_reg_invalidpointer),
+
+		/* TEST CASE 4: Test to calculate bit rate data metrics
+		 * with invalid bit rate data
+		 */
+		TEST_CASE(test_stats_bitrate_calc_invalid_bitrate_data),
+
+		/* TEST CASE 5: Test to calculate bit rate data metrics
+		 * with portid exceeding the max ports
+		 */
+		TEST_CASE(test_stats_bitrate_calc_invalid_portid_1),
+
+		/* TEST CASE 6: Test to calculate bit rate data metrics
+		 * with portid less than 0
+		 */
+		TEST_CASE(test_stats_bitrate_calc_invalid_portid_2),
+
+		/* TEST CASE 7: Test to calculate bit rate data metrics
+		 * with non-existing portid
+		 */
+		TEST_CASE(test_stats_bitrate_calc_non_existing_portid),
+
+		/* TEST CASE 8: Test to calculate bit rate data metrics
+		 * with valid portid, valid bit rate data
+		 */
+		TEST_CASE_ST(test_bit_packet_forward, NULL,
+				test_stats_bitrate_calc),
+		TEST_CASES_END()
+	}
+};
+
+static int
+test_bitratestats(void)
+{
+	return unit_test_suite_runner(&bitratestats_testsuite);
+}
+REGISTER_TEST_COMMAND(bitratestats_autotest, test_bitratestats);